if (MPI_CXX_FOUND)
    find_package(MPI)
endif ()

function(setup_mpi_target target)
    if (MPI_CXX_FOUND)
        target_link_libraries(${target} PRIVATE MPI::MPI_CXX)
        if (${CMAKE_HOST_SYSTEM_NAME} MATCHES "Linux")
            target_link_libraries(${target} PRIVATE rt)
        endif ()
    else ()
        message(SEND_ERROR "MPI not found, ${target} will not be built")
    endif ()
endfunction()