// Copyright 2021 Lawrence Livermore National Security, LLC and other Metall
// Project Developers. See the top-level COPYRIGHT file for details.
//
// SPDX-License-Identifier: (Apache-2.0 OR MIT)

#ifndef METALL_JSON_JSON_HPP
#define METALL_JSON_JSON_HPP

#include <metall/json/json_fwd.hpp>

#include <metall/json/array.hpp>
#include <metall/json/key_value_pair.hpp>
#include <metall/json/value.hpp>
#include <metall/json/string.hpp>
#include <metall/json/parse.hpp>
#include <metall/json/serialize.hpp>
#include <metall/json/pretty_print.hpp>
#include <metall/json/value_from.hpp>
#include <metall/json/value_to.hpp>
#include <metall/json/object.hpp>
#include <metall/json/equal.hpp>

/// \example json_create.cpp
/// This is an example of how to create a JSON object with Metall.

/// \example json_open.cpp
/// This is an example of how to open an already created JSON object.

#endif  // METALL_JSON_JSON_HPP
